unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, GLScene, GLObjects, GLCoordinates,
  GLCrossPlatform, BaseClasses, GLWin32Viewer, GLGeomObjects, AsyncTimer,
  Vcl.StdCtrls, Vcl.ComCtrls;

type
  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLDummyCube1: TGLDummyCube;
    GLCylinder1: TGLCylinder;
    GLCylinder2: TGLCylinder;
    GLCylinder3: TGLCylinder;
    GLSphere1: TGLSphere;
    AsyncTimer1: TAsyncTimer;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    TrackBar1: TTrackBar;
    Label3: TLabel;
    Label4: TLabel;
    procedure GLSceneViewer1MouseDown(Sender: TObject;
      Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AsyncTimer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure TrackBar1Change(Sender: TObject);
    
  private
    { Private declarations }
    x1,y1 : integer;
    theta : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// se ejecuta solo al crear la aplicacion
procedure TForm1.FormCreate(Sender: TObject);
begin
  theta := 0;
end;

// gira o detiene con teclas
procedure TForm1.FormKeyPress(Sender: TObject;
   var Key: Char);
begin
  Label1.Caption := Key;

  Key := UpCase(Key);
  if Key = 'A' then AsyncTimer1.Enabled := false;
  if Key = 'G' then AsyncTimer1.Enabled := true;

  if Key = '+' then begin

  end;

  if Key = '-' then begin

  end;
end;

procedure TForm1.FormMouseWheel(Sender: TObject;
  Shift: TShiftState;
  WheelDelta: Integer;
  MousePos: TPoint;
  var Handled: Boolean);
begin
   //
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject;
  Shift: TShiftState;
  MousePos: TPoint;
  var Handled: Boolean);
var
  esca : single;
begin
  esca := GLCamera1.SceneScale;
  esca := esca - 0.05;

  if esca < 0.1 then esca := 0.1;
  GLCamera1.SceneScale := esca;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject;
  Shift: TShiftState;
  MousePos: TPoint;
  var Handled: Boolean);
var
  esca : single;
begin
  esca := GLCamera1.SceneScale;
  esca := esca + 0.05;

  if esca > 5 then esca := 5;
  GLCamera1.SceneScale := esca;
end;

// gira o detiene con el boton
procedure TForm1.Button1Click(Sender: TObject);
begin
  if Button1.Caption = 'Gira' then begin
    AsyncTimer1.Enabled := true;
    Button1.Caption := 'Alto';
  end
  else
    if Button1.Caption = 'Alto' then begin
      AsyncTimer1.Enabled := false;
      Button1.Caption := 'Gira';
    end;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  x1 := X;
  y1 := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject;
  Shift: TShiftState;
  X, Y: Integer);
begin
  if (ssLeft in Shift) then begin
    GLCamera1.MoveAroundTarget(Y-y1,X-x1);
    x1 := X;
    y1 := Y;
  end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var
  pos : integer;
  int : single;
begin
  pos := TrackBar1.Position;
  Label4.Caption := IntToStr(pos)+' %';

  int := pos/100;

  GLLightSource1.Diffuse.Red   := int;
  GLLightSource1.Diffuse.Green := int;
  GLLightSource1.Diffuse.Blue  := int;
end;

procedure TForm1.AsyncTimer1Timer(Sender: TObject);
begin
  theta := theta + 5;
  GLDummyCube1.TurnAngle := theta;

  if theta >= 360 then  theta := 0;
   
end;


end.
